/*
 * timer.c
 *
 *  Created on: 20.7.2010
 *      Author: M.inko
 */

#include "timer.h"


// set prescaler on timer 0
void timer0SetPrescaler(BYTE prescale)
{
	outb(TCCR0B, (inb(TCCR0B) & ~TIMER_PRESCALE_MASK) | prescale);
}

//detail description is in the time.h
void delay_us_loops(WORD delay_loops)
{
WORD dummy;
	// one loop takes 4 cpu cycles
	asm volatile ("\n"
                  "mov %A0, %A1\n\t"
                  "mov %B0, %B1\n"
                  "L_dl2%=:\n\t"
                  "sbiw %A0, 1\n\t"
                  "brne L_dl2%=\n\t"
				  :"=&w" (dummy) //& means usage of register only, not memory variable
                  :"r"((unsigned short) (delay_loops))
	);
}

